import { StateStream } from 'rxact';
import createObserver from './createObserver';

StateStream.prototype.observer = function observer(mapStateToProps, mergeProps) {
  if (this._observer) {
    return this._observer(mapStateToProps, mergeProps);
  }

  var _createObserver = createObserver(this.state$),
      decorator = _createObserver.decorator,
      subscription = _createObserver.subscription;

  this._observer = decorator;
  this.subscriptions.push(subscription);

  return decorator(mapStateToProps, mergeProps);
};