'use strict';

var _rxact = require('rxact');

var _createObserver2 = require('./createObserver');

var _createObserver3 = _interopRequireDefault(_createObserver2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_rxact.StateStream.prototype.observer = function observer(mapStateToProps, mergeProps) {
  if (this._observer) {
    return this._observer(mapStateToProps, mergeProps);
  }

  var _createObserver = (0, _createObserver3.default)(this.state$),
      decorator = _createObserver.decorator,
      subscription = _createObserver.subscription;

  this._observer = decorator;
  this.subscriptions.push(subscription);

  return decorator(mapStateToProps, mergeProps);
};