(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("rxact"), require("react"));
	else if(typeof define === 'function' && define.amd)
		define(["rxact", "react"], factory);
	else if(typeof exports === 'object')
		exports["rxcat"] = factory(require("rxact"), require("react"));
	else
		root["rxcat"] = factory(root["Rxact"], root["React"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_1__, __WEBPACK_EXTERNAL_MODULE_5__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 2);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_rxact__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_rxact___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_rxact__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__createObserver__ = __webpack_require__(3);



__WEBPACK_IMPORTED_MODULE_0_rxact__["StateStream"].prototype.observer = function observer(mapStateToProps, mergeProps) {
  if (this._observer) {
    return this._observer(mapStateToProps, mergeProps);
  }

  var _createObserver = Object(__WEBPACK_IMPORTED_MODULE_1__createObserver__["a" /* default */])(this.state$),
      decorator = _createObserver.decorator,
      subscription = _createObserver.subscription;

  this._observer = decorator;
  this.subscriptions.push(subscription);

  return decorator(mapStateToProps, mergeProps);
};

/***/ }),
/* 1 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_1__;

/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

__webpack_require__(0);
module.exports = __webpack_require__(0);


/***/ }),
/* 3 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_hoist_non_react_statics__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_hoist_non_react_statics___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_hoist_non_react_statics__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_react__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxact__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxact___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxact__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__utils_noop__ = __webpack_require__(6);
var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }







var setDisplayName = function setDisplayName(component) {
  var displayName = component.displayName || component.name || 'Component';

  return 'RxactObserver(' + displayName + ')';
};

var defaultMergeProps = function defaultMergeProps(state, props) {
  return _extends({}, props, state);
};

var createObserver = function createObserver(state$) {
  var Observable = Object(__WEBPACK_IMPORTED_MODULE_2_rxact__["getObservable"])();

  if (!Object(__WEBPACK_IMPORTED_MODULE_2_rxact__["isObservable"])(state$)) {
    throw new Error('Expect state$ to be instance of Observable');
  }

  var streamSubscription = { unsubscribe: function unsubscribe() {} };
  var decorator = function decorator(mapStateToProps) {
    var mergeProps = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultMergeProps;
    return function (WrappedComponent) {
      var Observer = function (_Component) {
        _inherits(Observer, _Component);

        function Observer(props) {
          _classCallCheck(this, Observer);

          var _this = _possibleConstructorReturn(this, (Observer.__proto__ || Object.getPrototypeOf(Observer)).call(this, props));

          _this.subscription = null;
          _this.setProps = __WEBPACK_IMPORTED_MODULE_3__utils_noop__["a" /* default */];
          _this.props$ = __WEBPACK_IMPORTED_MODULE_3__utils_noop__["a" /* default */];
          _this.state = {
            component: null
          };
          _this.component = null;


          _this.props$ = new Observable(function (observer) {
            _this.setProps = function (props) {
              return observer.next(props);
            };

            _this.setProps(_this.props);

            return {
              unsubscribe: function unsubscribe() {
                _this.setProps = __WEBPACK_IMPORTED_MODULE_3__utils_noop__["a" /* default */];
              }
            };
          });
          return _this;
        }

        _createClass(Observer, [{
          key: 'componentWillMount',
          value: function componentWillMount() {
            var _this2 = this;

            var stream$ = state$;

            var vdom$ = new Observable(function (observer) {
              var readyCount = 0;
              var streamState = void 0;
              var propState = void 0;
              var onSubscribe = function onSubscribe() {
                if (readyCount < 2) {
                  readyCount += 1;
                }

                if (readyCount > 1) {
                  var nextState = streamState;

                  if (typeof mapStateToProps === 'function') {
                    nextState = mapStateToProps(streamState, propState);
                  }

                  var componentProps = mergeProps(nextState, propState);

                  var nextVdom = __WEBPACK_IMPORTED_MODULE_1_react___default.a.createElement(WrappedComponent, componentProps);
                  observer.next(nextVdom);
                }
              };

              var propSubscription = _this2.props$.subscribe(function (state) {
                propState = state;
                onSubscribe();
              });
              streamSubscription = stream$.subscribe(function (state) {

                streamState = state;
                onSubscribe();
              });

              return {
                unsubscribe: function unsubscribe() {
                  streamSubscription.unsubscribe();
                  propSubscription.unsubscribe();
                }
              };
            });

            this.subscription = vdom$.subscribe(function (component) {
              _this2.component = component;
              _this2.forceUpdate();
            });
          }
        }, {
          key: 'componentWillUnmount',
          value: function componentWillUnmount() {
            if (this.subscription && typeof this.subscription.unsubscribe === 'function') {
              this.subscription.unsubscribe();
              this.subscription = null;
            }
          }
        }, {
          key: 'componentWillReceiveProps',
          value: function componentWillReceiveProps(nextProps) {
            this.setProps(nextProps);
          }
        }, {
          key: 'shouldComponentUpdate',
          value: function shouldComponentUpdate() {
            return false;
          }
        }, {
          key: 'render',
          value: function render() {
            return this.component;
          }
        }]);

        return Observer;
      }(__WEBPACK_IMPORTED_MODULE_1_react__["Component"]);

      Observer.displayName = setDisplayName(WrappedComponent);


      return __WEBPACK_IMPORTED_MODULE_0_hoist_non_react_statics___default()(Observer, WrappedComponent);
    };
  };

  return {
    decorator: decorator,
    subscription: streamSubscription
  };
};

/* harmony default export */ __webpack_exports__["a"] = (createObserver);

/***/ }),
/* 4 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/**
 * Copyright 2015, Yahoo! Inc.
 * Copyrights licensed under the New BSD License. See the accompanying LICENSE file for terms.
 */


var REACT_STATICS = {
    childContextTypes: true,
    contextTypes: true,
    defaultProps: true,
    displayName: true,
    getDefaultProps: true,
    mixins: true,
    propTypes: true,
    type: true
};

var KNOWN_STATICS = {
  name: true,
  length: true,
  prototype: true,
  caller: true,
  callee: true,
  arguments: true,
  arity: true
};

var defineProperty = Object.defineProperty;
var getOwnPropertyNames = Object.getOwnPropertyNames;
var getOwnPropertySymbols = Object.getOwnPropertySymbols;
var getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;
var getPrototypeOf = Object.getPrototypeOf;
var objectPrototype = getPrototypeOf && getPrototypeOf(Object);

module.exports = function hoistNonReactStatics(targetComponent, sourceComponent, blacklist) {
    if (typeof sourceComponent !== 'string') { // don't hoist over string (html) components

        if (objectPrototype) {
            var inheritedComponent = getPrototypeOf(sourceComponent);
            if (inheritedComponent && inheritedComponent !== objectPrototype) {
                hoistNonReactStatics(targetComponent, inheritedComponent, blacklist);
            }
        }

        var keys = getOwnPropertyNames(sourceComponent);

        if (getOwnPropertySymbols) {
            keys = keys.concat(getOwnPropertySymbols(sourceComponent));
        }

        for (var i = 0; i < keys.length; ++i) {
            var key = keys[i];
            if (!REACT_STATICS[key] && !KNOWN_STATICS[key] && (!blacklist || !blacklist[key])) {
                var descriptor = getOwnPropertyDescriptor(sourceComponent, key);
                try { // Avoid failures from read-only properties
                    defineProperty(targetComponent, key, descriptor);
                } catch (e) {}
            }
        }

        return targetComponent;
    }

    return targetComponent;
};


/***/ }),
/* 5 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_5__;

/***/ }),
/* 6 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony default export */ __webpack_exports__["a"] = (function () {});

/***/ })
/******/ ]);
});